﻿init python:
    import random
    import time
    random.seed(time.clock())
    def choose_table(table):
        sum1 = 0
        for i in table:
            sum1 += i[0]
        r = random.randint(1,sum1)
        sum2 = 0
        for i in table:
            sum2 += i[0]
            if r <= sum2:
                return i
    def is_black(image, x, y):
        # img_size = renpy.image_size(image)
        img = renpy.load_surface(image)
        color = img.get_at((x, y))
        if color[0] == 0:
            return True
        return False

    class map_click:
        def __init__(self, name, pos = (0,0), action = None, image = "map_marker"):
            self.name = name
            self.pos = pos
            self.action = action
            self.image = image
            self.canons = 0
            self.fighters = 0
            self.event_log = []
            self.fight_ballance = 0
        def fight(self, player, events):
            if abs(self.fight_ballance) > 100:
                return
            e = choose_table(events)
            if e[3]:
                if e in self.event_log:
                    return
            self.event_log.append(e)
            self.fight_ballance += e[2]
            if e[2] < 0:
                color = "#700"
            else:
                color = "#070"
            if not e[3]:
                color += "9"
            msg.msg(e[1], color)


    class map_class:
        def __init__(self, name, clicks, spawns, tiles):
            self.name = name
            self.clicks = clicks
            self.spawns = spawns
            self.water = "images/map_water.png"
        def add(self, location):
            if not location in self.clicks:
                self.clicks.append(location)
        def remove(self, location):
            if location in self.clicks:
                self.clicks.remove(location)
        def spawn(self):
            x = random.randint(60, 1860)
            y = random.randint(60, 1020)
            if is_black(self.water, x, y):
                s = random.choice(self.spawns)
                spawn = map_click(s.name, (x,y), s.action, s.image)
                self.clicks.append(spawn)
                return
            
            self.spawn()



default the_white_beach = map_click("The white beach", (1411,428), Jump("the_white_beach"))
default scarlet_rocks = map_click("The scarlet rocks", (1117,679), Jump("scarlet_rocks"))

default the_corridor = map_class(
    "The corridor",
    [
        # booty_bay,
        # the_white_beach,
        # scarlet_rocks,
    ],
    [
        map_click(name = "Spanish cargo", action = Jump("attacking_spanish_cargo"), image = "spanish_cargo"),
        map_click(name = "Wrecked ship", action = Jump("rescue_mission"), image = "wrecked_ship"),
        map_click(name = "Red boat", action = Jump("red_mystery"), image = "red_boat"),
    ],[]
)
screen map_screen(g = the_corridor):
    modal False
    style_prefix "map"

    for i in g.clicks:
        button:
            xysize 100,100 background None
            pos i.pos align .5,.5
            add i.image align .5,.5
            action i.action
        button:
            pos i.pos background None
            align .5,.5 yoffset 40
            frame:
                at nameplate_sway(random.random())
                background Frame("map_title_plate", 20,0)
                padding 20,0 ysize 28
                text i.name color "#260a02" size 22
            action i.action

    # button:
    #     text "test"
    #     action Function(g.spawn)
    
transform nameplate_sway(delay):
    subpixel True
    alpha 0
    pause delay
    ease 1 alpha 1
    block:
        ease 2 yoffset 10
        ease 2 yoffset 0
        repeat

default battle_events = [
    [10, "A canon hit your ship.", -20, False],
    [10, "Your canon hit their ship.", 20, False],
    [30, "One of your crew got shot.", -5, False],
    [30, "One of your crew got shot.", 5, False],
    [30, "One of your crew got wounded.", -5, False],
    [30, "You've wounded one of their crew.", 5, False],
    [15, "Torn  their clothing.", 3, False],
    [15, "Torn your clothing.", 3, False],
    [15, "One of your crew running.", -3, False],
    [15, "One of Their crew running.", 3, False],
    [15, "They scream.", 1, False],
    [15, "Your crew screams.", 1, False],
    [2, "Somebody farted.", 0, False],
    [12, "Crew overboard!.", -13, False],
    [12, "One of them fell overboard!.", 13, False],



    [5, "They've boarded your ship.", -50, True],
    [5, "You've boarded their ship.", 50, True],
    [15, "Fire on your deck.", -30, True],
    [15, "Fire on their deck.", 30, True],
]

default players_fleet = map_click("Red death")
screen battle(g, player = players_fleet, events = battle_events):
    modal True
    style_prefix "battle"
    timer 1 repeat True action Function(g.fight, player, events)
    frame:
        at fight_beat
        padding 20,20 align .5,.5
        add "ship_fight_1"
    text str(g.fight_ballance)

    if g.fight_ballance > 100:
        frame:
            padding 20,20 align .5,.9
            vbox:
                spacing 20
                text "The day is yours."
                button:
                    text "Collect your booty"
                    action Return("won")
    elif g.fight_ballance < -100:
        frame:
            padding 20,20 align .5,.9
            vbox:
                spacing 20
                text "You have lost."
                button:
                    text "Jump ship"
                    action Return("lost")
    else:
        button:
            align .5,1.0
            text "Bail"
            action Return("ran")

    vbox:
        yoffset 200
        button:
            text "Test win"
            action Return("won")
        button:
            text "test lose"
            action Return("lost")
        

style battle_button is zero
style battle_frame is zero

transform fight_beat:
    subpixel True
    ease 10 zoom 1.2
    ease 10 zoom 1
    repeat

label map:
    scene map_background with dissolve
    call screen map_screen








label the_white_beach:
    scene bg the_white_beach
    "Capitan smiles."
    jump map

label scarlet_rocks:
    scene bg scarlet_rocks
    "Something else."
    jump map


label attacking_spanish_cargo:
    scene bg attacking_spanish_cargo
    "A fight will happen here"
    jump map

label rescue_mission:
    scene bg rescue_mission
    "Top off your crew."
    jump map

label red_mystery:
    scene bg red_mystery
    "Top off your crew."
    jump map